Fixed bug in specifying audio tracks for Handbrake
[rip_dvd/.git] / rip_dvd
1 #!/bin/bash
2 #
3 # Author: Alan J. Pippin (apippin@pippins.net)
4 # Date: 05/17/2009
5 #
6   REV=2.0
7 #
8 # Description: This script wraps a number of linux utilities to
9 # create a recipe for ripping protected DVDs, circumventing 
10 # ARcoSS and CRC checksum error protection schemes used on many
11 # newer DVDs. Edit as appropriate for your needs. I use this to
12 # backup DVDs I own, and do not condone any other activity it
13 # may be used for.
14 #
15 # Known Issues/Limitations:
16 # - Mirror mode is always done in ISO mode
17 #
18 # Package Dependencies (apt-get install these for example):
19 # lsdvd dvdauthor gddrescue dvdbackup tovid mencoder mplayer genisoimage libdvdcss2
20 #
21 # Specific Executable (program) Dependencies (must be found in $PATH):
22 # volname makexml lsdvd dvdauthor gddrescue dvdbackup mencoder mplayer mkisofs HandBrakeCLI
23 #
24 # Optional Dependencies:
25 # lookup imdb info/posters for mythvideo: http://www.mythtv.org/wiki/Fill_mythvideo_metadata.pl
26 #
27
28 ##############################################################################################
29 # Global Variables
30 ##############################################################################################
31 typeset cmd="$0 $*"
32 typeset dvdname=""
33 typeset debug=""
34 typeset dest=""
35 typeset isofile=""
36 typeset vobfile=""
37 typeset dvdpath=""
38 typeset aspect=""
39 typeset SCALE=""
40 typeset CROP=""
41 typeset profile="xvidvhq"
42 typeset extension=""
43 typeset mailto=""
44 typeset encoder=""
45 typeset default_alang="en"
46 typeset track=""
47 typeset -i default_aid=128
48 typeset -i aid_override=-1
49 typeset -i force_onepass_mode=0
50 typeset -i eject_disk=1
51 typeset -i keep_isofile=0
52 typeset -i keep_vobfile=0
53 typeset -i keep_dvdfolder=0
54 typeset -i keep_intermediate_files=0
55 typeset -i make_final_dest_vob=0
56 typeset -i make_final_dest_iso=0
57 typeset -i make_final_dest_folder=0
58 typeset -i make_final_dest_comp=0
59 typeset -i errors=0
60 typeset -i show_usage=0
61 typeset -i mirror_mode=0
62 typeset -i target_bitrate=2000
63 typeset -i target_size=0
64 typeset -i audio_2ch=0
65 typeset -i audio_6ch=1
66 typeset -i invalid_feature_title=0
67 typeset -i feature_title_override=0
68 typeset -i mplayer_dumpstream_incompatibility=0
69
70 ##############################################################################
71 # Local Machine Settings:
72 # Sources both the "default" conf file tracked by GIT (rip_dvd.conf.dist)
73 # and the local conf file created by each local machine (rip_dvd.conf)
74 # Copy the rip_dvd.conf.dist file to rip_dvd.conf and edit the later.
75 # This will allow you to override all the default values to meet your needs
76 # in a way that won't get clobbered when you pull updates from my GIT repo.
77 ##############################################################################
78 config="${0%/*}/rip_dvd.conf"
79
80 # The config file will be searched for in the following location order:
81 found_config=0
82
83 # 1) /path/to/rip_dvd/script/rip_dvd.conf.dist
84 [ -e "${config}.dist" ] && found_config=1 && . "${config}.dist"
85
86 # 2) /path/to/rip_dvd/script/rip_dvd.conf
87 [ -e "${config}" ] && found_config=1 && . "${config}"
88
89 # 3) /etc/rip_dvd.conf
90 [ -e "/etc/rip_dvd.conf" ] && found_config=1 && . "/etc/rip_dvd.conf"
91
92 # 4) $PWD/rip_dvd.conf
93 [ -e "$PWD/rip_dvd.conf" ] && found_config=1 && . "$PWD/rip_dvd.conf"
94
95 # Check to make sure we found the config file
96 if [ $found_config -eq 0 ]; then
97   echo "-E- Unable to find the rip_dvd.conf file: $config"
98   exit 1
99 fi
100
101 ##############################################################################################
102 # Command line processing
103 ##############################################################################################
104 while (($#)) && getopts 162mvifkzx:ht:n:d:b:s:t:a:p:e:j:l: opt "$@"
105 do
106     case $opt in
107         (n)     dvdname=$OPTARG;;
108         (d)     dest=$OPTARG;;
109         (b)     target_bitrate=$OPTARG;;
110         (s)     target_size=$OPTARG;;
111         (2)     audio_2ch=1;;
112         (6)     audio_6ch=1;;
113         (1)     force_onepass_mode=1;;
114         (v)     make_final_dest_vob=1;;
115         (i)     make_final_dest_iso=1;;
116         (f)     make_final_dest_folder=1;; 
117         (z)     make_final_dest_comp=1;;
118         (e)     encoder=$OPTARG;;
119         (m)     mirror_mode=1;;
120         (k)     keep_intermediate_files=1;;
121         (t)     feature_title_override=$OPTARG;;
122         (a)     aspect=$OPTARG;;
123         (p)     profile=$OPTARG;;
124         (x)     extension=$OPTARG;;
125         (j)     eject_disk=$OPTARG;;
126         (l)     aid_override=$OPTARG;;
127         (w)     set -$opt;;
128         (h)     show_usage=1;;
129         (:)     echo >&2 "$0: $OPTARG requires a value"; errors=errors+1;;
130         (\?)    echo >&2 "$0: invalid option '$OPTARG'"; errors=errors+1;;
131     esac
132 done
133
134 shift $((OPTIND-1))
135
136 function usage() {
137     echo >&2 "Usage: ${0##*/} -d <destdir> [ <options> ]"
138     echo >&2 "Revision $REV"
139     echo >&2 "Options:"
140     echo >&2 "   -d <destdir>  Specify the destination directory to store the ripped DVD to"
141     echo >&2 "   -n <dvdname>  Specify a path to a DVD folder or file to process:"
142     echo >&2 "                 1) If this option is not specified, the DVD will be ripped from $dev"
143     echo >&2 "                 2) If dvdname is a full path to a DVD folder, it will be ripped as a DVD instead of $dev"
144     echo >&2 "                 3) If dvdname is a full path to an MPG2 file, it will be ripped as a DVD instead of $dev"
145     echo >&2 "                 4) If dvdname is a full path to an ISO file, it will be ripped as a DVD instead of $dev"
146     echo >&2 "                 5) If dvdname is a full path to a VOB file, it will be ripped as a DVD instead of $dev"
147     echo >&2 "   -p <profile>  Specify which encoding profile to use in -x mode as shown below:"
148     echo >&2 "                 Mencoder and Handbrake Encoder Profiles:"
149     echo >&2 "                 - xvidvhq = AVI, very high quality encoding, Xvid codec, 2 pass encoding (default)"
150     echo >&2 "                 - xvidhq = AVI, high quality encoding, Xvid codec, 2 pass encoding"
151     echo >&2 "                 - xvid = AVI, fast encoding, Xvid codec, 2 pass encoding"
152     echo >&2 "                 - iphone = MP4, x264 codec, 2 pass encoding, forced 480:320 scaling"
153     echo >&2 "                 - ipod = MP4, x264 codec, 2 pass encoding, forced 320:240 scaling"
154     echo >&2 "                 Handbrake Only Encoder Profiles:"
155     echo >&2 "                 - mp4vhq = MP4, very high quality encoding, x264 codec, 2 pass encoding"
156     echo >&2 "                 - mp4hq = MP4, high quality encoding, x264 codec, 2 pass encoding"
157     echo >&2 "                 - mp4 = MP4, fast encoding, x264 codec, 2 pass encoding"
158     echo >&2 "                 - hb_<profile> = Any predefined HandBrake profile"
159     echo >&2 "   -x <ext>      Specify a suffix extension to apply to the end of the final image filename (like .xvid, .ipod, etc)"
160     echo >&2 "                 If you run multiple instances of this script ripping the same DVD, you need to specify this option."
161     echo >&2 "   -m            Make a mirror image of the DVD and save it as a DVD ISO file"
162     echo >&2 "                 The default operation is non-mirror mode where only the main"
163     echo >&2 "                 feature title will be ripped."
164     echo >&2 "   -v            Make the final image a DVD VOB file"
165     echo >&2 "   -i            Make the final image a DVD ISO file"
166     echo >&2 "   -f            Make the final image a DVD folder"
167     echo >&2 "   -z            Make the final image a compressed file based on your profile selection and encoder"
168     echo >&2 "   -e <encoder>  Specify the encoder to use to make the compressed file (valid encoders=mencoder|handbrake) (default=handbrake if found)"
169     echo >&2 "                 You must also specify the target size or bitrate using the '-s' or '-b' options"
170     echo >&2 "   -s <size>     Set the target size of the compressed file in MB (ex: 700, 1000, etc)"
171     echo >&2 "   -b <bitrate>  Set the bitrate desired in the compressed file in kbits/sec (ex: 1500, 2000 (default), etc)"    
172     echo >&2 "   -a <W:H>      Specify the width x height aspect ratio to scale the DVD to (only used in -x mode)"
173     echo >&2 "      <W>        If only the width is given, it will autoset the height to a value which preserves the aspect ratio"
174     echo >&2 "                 The default behavior is autoaspect mode, which preserves the original aspect, with no scaling being done"
175     echo >&2 "   -j <n>        Eject the disk:"
176     echo >&2 "                 - 0 = do not eject the disk"
177     echo >&2 "                 - 1 = eject after the entire script is done (default)"
178     echo >&2 "                 - 2 = eject after the disk is no longer needed (prior to starting the encode process)"
179     echo >&2 "                 The last option will allow you to start ripping another disk while the encoding process is running on a previous"
180     echo >&2 "   -1            Force 1-pass encoding mode across all profiles"
181     echo >&2 "   -2            Use 2 channel MP3 audio encoding when making a compressed file (default is 6 channel AC3)"
182     echo >&2 "   -6            Use 6 channel AC3 audio encoding when making a compressed file (default)"
183     echo >&2 "   -k            Keep the intermediate files (good for debugging)"
184     echo >&2 "                 In -x mode, run with this option to keep the original .VOB file"
185     echo >&2 "                 By default, all intermediary files are deleted. Only the final image is kept"
186     echo >&2 "   -l <aid>      Specify the audio AID language ID to rip from the source DVD"
187     echo >&2 "   -t <title>    Specify the main feature title to pull from the DVD (only required if this script can't figure it out)"
188     echo >&2 "   -w            Set the sh Execute/Verbose flag (causes every command to be echoed)"
189     echo >&2 ""
190     exit 2
191 }
192
193 if (($errors)) || (($show_usage))
194 then
195   usage
196 fi
197
198 # Sanity Check - Command Line Options 
199 if [ "$dest" == "" ]; then
200   echo "-E- You must specify a destination directory with '-d'" | tee -a $logfile
201   usage
202 fi
203
204 if ([ $target_size -ne 0 ] || [ "$aspect" != "" ]) && [ $make_final_dest_comp -ne 1 ]; then
205   echo "-E- You can't specify a target_size, or aspect in non compressed file mode. You must specify '-x' when using '-b' or '-s' or '-a'" | tee -a $logfile
206   usage
207 fi
208
209 if [ $target_bitrate -eq 0 ] && [ $target_size -eq 0 ] && [ $make_final_dest_comp -eq 1 ]; then
210   echo "-E- You must specify a bitrate in compressed file mode. You must specify '-b' or '-s' when using '-x'" | tee -a $logfile
211   usage
212 fi
213
214 if [ $make_final_dest_vob -eq 0 ] && [ $make_final_dest_iso -eq 0 ] && 
215    [ $make_final_dest_folder -eq 0 ] && [ $make_final_dest_comp -eq 0 ] && [ $mirror_mode -eq 0 ]; then
216   echo "-E- You must specify what type of final destination you want: '-m' or '-v' or '-i' or '-f' or '-z'" | tee -a $logfile
217   usage
218 fi
219
220 if [ $mirror_mode -eq 1 ]; then
221   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_iso -eq 1 ] || 
222      [ $make_final_dest_folder -eq 1 ] || [ $make_final_dest_comp -eq 1 ]; then
223     echo "-E- You can't specify '-v' or '-i' or '-f' or '-x' when operating in mirror mode with '-m'" | tee -a $logfile
224     usage
225   fi
226 fi
227
228 # Make handbrake the default encoder if not specified and we can find it
229 if [ -z "$encoder" ]; then
230   encoder="mencoder"; # If we can't find handbrake, set mencoder as the default
231   [[ -x `which $handbrake_xvid` ]] && [[ "$profile" =~ "xvid" ]] && encoder="handbrake";
232   [[ -x `which $handbrake_mp4` ]] && [[ "$profile" =~ "mp4" ]] && encoder="handbrake";
233   [[ -x `which $handbrake_mp4` ]] && [[ "$profile" =~ "hb" ]] && encoder="handbrake";
234 fi
235
236 # Sanity check the profile selection
237 if [[ "$encoder" == "mencoder" ]]; then
238   [[ "$profile" =~ "mp4" ]] && echo "-E- invalid encoder $encoder selected for mp4 profile: $profile" && exit
239 fi
240
241 if [[ "$encoder" != "mencoder" ]] && [[ "$encoder" != "handbrake" ]]; then
242   echo "-E- Invalid encoder specified: $encoder"
243   exit 1
244 fi
245
246 # If the aspect ratio option was specified, set the scale variable appropriately for mencoder
247 if [ "$aspect" != "" ]; then
248   echo "$aspect" | grep -q "x"
249   if [ $? == 0 ]; then
250     echo "-E- You must specify the aspect option with a value whose format is W:H"
251     exit 1
252   fi
253   echo "$aspect" | grep -q ":"
254   if [ $? != 0 ]; then
255     SCALE=",scale -zoom -sws 9 -xy $aspect"
256   else
257     SCALE=",scale=$aspect"
258   fi
259 fi
260
261 # Sanity Check - Key executables
262 [[ ! -x `which lsdvd` ]] && echo "-E- missing dependency: lsdvd" && exit
263 [[ ! -x `which volname` ]] && echo "-E- missing dependency: volname" && exit
264 [[ ! -x `which ddrescue` ]] && echo "-E- missing dependency: ddrescue" && exit
265 [[ ! -x `which dvdbackup` ]] && echo "-E- missing dependency: dvdbackup" && exit
266 [[ ! -x `which mencoder` ]] && echo "-E- missing dependency: mencoder" && exit
267 [[ ! -x `which makexml` ]] && echo "-E- missing dependency: makexml" && exit
268 [[ ! -x `which dvdauthor` ]] && echo "-E- missing dependency: dvdauthor" && exit
269 [[ ! -x `which mkisofs` ]] && echo "-E- missing dependency: mkisofs" && exit
270 [[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "xvid" ]] && [[ ! -x `which $handbrake_xvid` ]] && echo "-E- missing encoder: $handbrake_xvid" && exit
271 [[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "mp4" ]] && [[ ! -x `which $handbrake_mp4` ]] && echo "-E- missing encoder: $handbrake_mp4" && exit
272 [[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "hb" ]] && [[ ! -x `which $handbrake_mp4` ]] && echo "-E- missing encoder: $handbrake_mp4" && exit
273 [[ "$encoder" == "handbrake" ]] && [[ ! -x `which ffmpeg` ]] && echo "-E- missing dependency: ffmpeg" && exit
274
275 ##############################################################################################
276
277 typeset -i ripdvd
278 if [ -z "$dvdname" ]; then
279
280   # make sure the DVD device is accessible
281   volname $dev > /dev/null 2>&1
282   if [ $? != 0 ]; then
283     echo "-E- Can't access the DVD device $dev"
284     exit 1
285   fi
286   # now capture the volume name from the device
287   dvdname=`volname $dev | awk '{ print $1 }'`
288   ripdvd=1
289
290 else 
291
292   # check to see if dvdname is a full path to a real directory
293   # if it is, set dvdname and dvdpath appropriately
294   if [ -d "$dvdname" ]; then
295     dvdpath="$dvdname"
296     dvdname=`basename "$dvdname"`
297     keep_dvdfolder=1
298     if [ -z "$dvdname" ]; then
299      echo "-E- Unable to extract dvdname from path: $dvdpath"
300      exit 1
301     fi
302     if [ ! -d "$dvdpath/VIDEO_TS" ]; then
303       echo "-E- You must supply a full path to a valid DVD folder with this option"
304       exit 1
305     fi
306   fi
307
308   # Check to see if dvdname is a full path to a file
309   if [ -f "$dvdname" ]; then
310     valid_file=0
311
312     # check to see if dvdname is a full path to an MPG2 (VOB) file
313     # if it is, set dvdname and vobfile appropriately
314     file "$dvdname" | grep -q "MPEG"
315     if [ $? == 0 ]; then
316       # It is a valid MPEG2 file, now strip the extension off our dvdname
317       vobfile="$dvdname"
318       dvdname=`basename "$dvdname"`
319       dvdname=${dvdname%.[^.]*}
320       keep_vobfile=1
321       valid_file=1
322     fi
323
324     # check to see if dvdname is a full path to an ISO file
325     # if it is, set dvdname and isofile appropriately
326     file "$dvdname" | grep -q -e "ISO" -e "UDF"
327     if [ $? == 0 ]; then
328       # It is a valid ISO file, now strip the extension off our dvdname
329       isofile="$dvdname"
330       dvdname=`basename "$dvdname"`
331       dvdname=${dvdname%.[^.]*}
332       keep_isofile=1
333       valid_file=1
334     fi    
335
336     # check to see if dvdname is a full path to an ISO file
337     # if it is, set dvdname and isofile appropriately
338     file "$dvdname" | grep -q -e "VOB"
339     if [ $? == 0 ]; then
340       # It is a valid VOB file, now strip the extension off our dvdname
341       vobfile="$dvdname"
342       dvdname=`basename "$dvdname"`
343       dvdname=${dvdname%.[^.]*}
344       keep_vobfile=1
345       valid_file=1
346     fi    
347
348     # If we didn't find a handler for the file above, complain
349     if [ $valid_file -eq 0 ]; then
350       echo "-E- Unsupported file type: $vobfile"
351       exit 1
352     fi
353
354   # Throw an error if we can't find what the -n option is pointing to
355   else 
356     echo "-E- Unable to find the directory or file specified by the '-n $dvdname' option. Please make sure the path is valid."
357     exit 1
358   fi
359
360   # Set the ripdvd flag to false since we aren't ripping a DVD disk
361   ripdvd=0
362
363   # Since we aren't ripping a DVD disk, don't eject anything either
364   eject_disk=0
365
366 fi
367
368 # remove bad characters from the dvdname
369 dvdname=${dvdname%.} # remove trailing '.' character
370
371 # add the suffix extension to the end of the dvdname
372 dvdname=$dvdname$extension
373
374 # make a "safe" dvdname (remove special characters)
375 safedvdname=`basename "$dvdname" | sed 's/[ !&*\\$?]/_/g'`
376
377 # Make sure we have a non-empty dvdname
378 if [ -z "$dvdname" ]; then
379   echo "-E- unable to determine dvdname"
380   exit 1
381 fi
382
383 # make sure our vobfile value is set
384 if [ -z "$vobfile" ]; then
385   vobfile="$dest/$dvdname.VOB"
386 fi
387
388 # set up some variables to hold various logfiles
389 logfile="$logdir/$dvdname.log"
390 passlogfile="$tmpdir/$safedvdname.log"
391 ddrescuelog=`tempfile`
392 dvdauthorlog=`tempfile`
393 encodelog=`tempfile`
394 dumplog=`tempfile`
395
396 # create the tmpdir if it doesn't already exist
397 if [ ! -d "$tmpdir" ]; then
398   mkdir -p "$tmpdir"
399   if [ $? != 0 ]; then
400     echo "-E- Unable to create the tmpdir: $tmpdir"
401     exit 1
402   fi
403 fi
404
405 # create the logdir if it doesn't already exist
406 if [ ! -d "$logdir" ]; then
407   mkdir -p "$logdir"
408   if [ $? != 0 ]; then
409     echo "-E- Unable to create the logdir: $logdir"
410     exit 1
411   fi
412 fi
413
414 ##############################################################################################
415 # cleanup functions
416 ##############################################################################################
417 cleanup() { 
418   if [ $keep_intermediate_files -eq 0 ]; then
419     [[ -e "$dvdauthorlog" ]] && rm -f "$dvdauthorlog"
420     [[ -e "$ddrescuelog" ]] && rm -f "$ddrescuelog"
421     [[ -e "$encodelog" ]] && rm -f "$encodelog"
422     [[ -e "$dumplog" ]] && rm -f "$dumplog"
423   else
424     [[ -e "$dvdauthorlog" ]] && echo "-> Keeping dvdauthor log: $dvdauthorlog" | tee -a "$logfile"
425     [[ -e "$ddrescuelog" ]] && echo "-> Keeping ddrescue log: $ddrescuelog" | tee -a "$logfile"
426     [[ -e "$encodelog" ]] && echo "-> Keeping encode log: $encodelog" | tee -a "$logfile"
427     [[ -e "$dumplog" ]] && echo "-> Keeping dump log: $dumplog" | tee -a "$logfile"
428   fi
429   echo ""
430 }
431
432 fatal_and_exit() {
433   if [[ -z "$1" ]]; then
434     msg="-E- control-c killed us"
435   else
436     msg=$1
437   fi
438   echo -e 2>&1 "$msg" | tee -a "$logfile"
439   if [[ -n "$mailto" ]]; then
440     echo -e "$msg" | mailx -s "dvd rip of $dvdname FAILED" "$mailto"
441   fi
442   keep_intermediate_files=1
443   exit 1
444 }
445
446 # Call our cleanup functions on INT and EXIT signals
447 trap fatal_and_exit INT
448 trap cleanup EXIT
449
450 ##############################################################################################
451 # processing functions
452 ##############################################################################################
453
454 # encode the vob file into a compressed file format using handbrake
455 function encode_vob_file_handbrake {
456   
457   # declare some globals
458   typeset handbrake_cli=""
459   typeset handbrake_video_encoder_opts=""
460   typeset filetype=""
461   typeset handbrake_audio_opts=""
462
463   # Set a variable that we will use later to determine if we found a handler for $profile or not
464   typeset -i found_profile=0    
465
466   # For a given profile, to override the 2 pass behavior to be single pass,
467   # simply set the PASSES variable below to "2" instead of "1 2" inside your profile handler. 
468   # It indicates which PASS numbers to loop over. PASSES="2" means just do pass 2 => single pass mode.
469   PASSES="-2"
470
471   # Check the global force_onepass_mode. If it is set, change our variables appropriately
472   # to force 1-pass encoding across all profiles.
473   if [ $force_onepass_mode -eq 1 ]; then
474     PASSES=""
475   fi
476
477   # get our audio track from the VOB file
478   get_audio_track_from_vob "$vobfile"
479
480   # XVID profile
481   if [[ "$profile" =~ "xvid" ]]; then
482     found_profile=1
483     handbrake_cli="$handbrake_xvid"
484     final_output_file="$dest/$dvdname.avi"
485     filetype="avi"
486
487     # Very High Quality (16fps)
488     if [ "$profile" == "xvidvhq" ]; then
489       handbrake_opts[0]="-f avi"
490       handbrake_opts[1]="-b $target_bitrate"
491       handbrake_opts[2]="-e ffmpeg"
492       handbrake_opts[3]="-T"
493       handbrake_opts[4]="-5"
494       handbrake_opts[5]="-8"
495     fi
496     # High Quality (20fps)
497     if [ "$profile" == "xvidhq" ]; then
498       handbrake_opts[0]="-f avi"
499       handbrake_opts[1]="-b $target_bitrate"
500       handbrake_opts[2]="-e ffmpeg"
501       handbrake_opts[3]="-T"
502       handbrake_opts[4]="-5"
503     fi
504     # Fast (28fps)
505     if [ "$profile" == "xvid" ]; then
506       handbrake_opts[0]="-f avi"
507       handbrake_opts[1]="-b $target_bitrate"
508       handbrake_opts[2]="-e ffmpeg"
509       handbrake_opts[3]="-T"
510     fi
511   fi
512
513   # MP4 profile
514   if [[ "$profile" =~ "mp4" ]]; then
515     found_profile=1
516     handbrake_cli="$handbrake_mp4"
517     final_output_file="$dest/$dvdname.mp4"
518     PASSES=""
519
520     # Very High Quality
521     if [ "$profile" == "mp4vhq" ]; then
522       profile="hb_High_Profile"
523     fi
524     # High Quality
525     if [ "$profile" == "mp4hq" ]; then
526       profile="hb_Normal"
527     fi
528     # Fast
529     if [ "$profile" == "mp4" ]; then
530       profile="hb_Classic"
531     fi
532   fi
533
534   # iphone and ipod MP4 profiles
535   if [ "$profile" == "iphone" ] || [ "$profile" == "ipod" ]; then
536     found_profile=1
537     handbrake_cli="$handbrake_mp4"
538     final_output_file="$dest/$dvdname.mp4"
539     PASSES=""
540
541     # iphone
542     if [ "$profile" == "iphone" ]; then
543       profile="hb_iPhone"
544     fi
545     # ipod
546     if [ "$profile" == "ipod" ]; then
547       profile="hb_iPod"
548     fi
549   fi
550   
551   # Predefined Handbrake Profile Handling
552   if [[ "$profile" =~ "hb" ]]; then
553     found_profile=1
554     handbrake_cli="$handbrake_mp4"
555     final_output_file="$dest/$dvdname.mp4"
556     PASSES=""
557     
558     # extract the HandBrake Profile name from $profile
559     hb_profile=`echo "$profile" | sed 's/hb_//g' | sed 's/_/ /g'`
560     handbrake_opts[0]="-Z \"$hb_profile\""
561   fi
562
563   # Make sure we found a handler for the given profile
564   if [ $found_profile -eq 0 ]; then
565     fatal_and_exit "-E- Unable to find a profile handler for profile: $profile"
566   fi
567
568   # setup our audio option
569   if [ $audio_2ch -eq 1 ] && [ $audio_6ch -eq 1 ]; then
570     handbrake_audio_opts="-E faac,ac3 -6 dpl2,none"
571   fi
572   if [ $audio_6ch -eq 1 ] && [ $audio_2ch -eq 0 ]; then
573     handbrake_audio_opts="-E ac3 -6 none"
574   fi
575   if [ $audio_2ch -eq 1 ] && [ $audio_6ch -eq 0 ]; then
576     handbrake_audio_opts="-E faac -6 dpl2"
577   fi
578   if [ -n "$track" ]; then
579     handbrake_audio_opts="$handbrake_audio_opts -a $track"
580   fi
581
582   # Convert our array of opts into a string
583   for OPTS in "${video_encoder_opts[@]}"; do 
584     handbrake_video_encoder_opts="$handbrake_video_encoder_opts:$OPTS"
585   done
586   if [ -n "$handbrake_video_encoder_opts" ]; then
587     handbrake_video_encoder_opts="-x $handbrake_video_encoder_opts"
588   fi
589   for OPTS in "${handbrake_opts[@]}"; do 
590     handbrake_cmd_line_opts="$handbrake_cmd_line_opts $OPTS"
591   done
592   
593   # Execute the handbrake command to encode the video
594   echo -e "\n   Encoding: $handbrake_cli -i \"$vobfile\" -o \"$final_output_file\" $handbrake_cmd_line_opts $handbrake_audio_opts $handbrake_video_encoder_opts $PASSES >> $encodelog 2>&1" >> "$logfile"
595   $handbrake_cli -i "$vobfile" -o "$final_output_file" $handbrake_cmd_line_opts $handbrake_audio_opts $handbrake_video_encoder_opts $PASSES >> $encodelog 2>&1
596   handbrake_retval=$?
597   if [ $handbrake_retval != 0 ]; then
598     fatal_and_exit "-E- Unhandled handbrake error"
599   fi
600
601   # Concatenate the encode log to our main log file, greping out unwanted lines
602   cat $encodelog | grep -v "Encoding" >> "$logfile" 
603   cat $encodelog | grep "Encoding:" | sed 's/\r/\n/g' | grep "Encoding:" | grep "ETA" | head -1 >> "$logfile"
604   cat $encodelog | grep "Encoding:" | sed 's/\r/\n/g' | grep "Encoding:" | grep "ETA" | tail -1 >> "$logfile"
605 }
606
607 # encode the vob file into a compressed file format using mencoder
608 function encode_vob_file_mencoder {
609
610   # Set a variable that we will use later to determine if we found a handler for $profile or not
611   typeset -i found_profile=0
612
613   # For a given profile, to override the 2 pass behavior to be single pass,
614   # simply set the PASSES variable below to "2" instead of "1 2" inside your profile handler. 
615   # It indicates which PASS numbers to loop over. PASSES="2" means just do pass 2 => single pass mode.
616   PASSES="1 2"
617
618   # Declare our default 2 pass variables
619   passlogfile_opt="-passlogfile $passlogfile"
620   pass_opt="pass=%PASS"
621
622   # Check the global force_onepass_mode. If it is set, change our variables appropriately
623   # to force 1-pass encoding across all profiles.
624   if [ $force_onepass_mode -eq 1 ]; then
625     PASSES="2"
626     passlogfile_opt=""
627     pass_opt=""    
628   fi
629
630   # XVID profile
631   if [[ "$profile" =~ "xvid" ]]; then
632     found_profile=1
633     final_output_file="$dest/$dvdname.avi"
634     mencoder_general_opts="$lang_opts $passlogfile_opt"
635     mencoder_output_opts="-ofps 30000/1001 -ffourcc DIVX"
636     mencoder_video_filter_opts="-vf pullup,softskip,hqdn3d=2:1:2$CROP$SCALE"
637     mencoder_video_encoder_opts="-ovc xvid -xvidencopts $pass_opt"
638
639     # Very High Quality (16fps)
640     if [ "$profile" == "xvidvhq" ]; then
641       video_encoder_opts[0]="bitrate=$target_bitrate"
642       video_encoder_opts[1]="threads=$mencoder_threads"
643       video_encoder_opts[2]="chroma_opt"
644       video_encoder_opts[3]="vhq=4"
645       video_encoder_opts[4]="bvhq=1"
646       video_encoder_opts[5]="quant_type=mpeg"
647       video_encoder_opts[6]="autoaspect"
648     fi
649     # High Quality (20fps)
650     if [ "$profile" == "xvidhq" ]; then
651       video_encoder_opts[0]="bitrate=$target_bitrate"
652       video_encoder_opts[1]="threads=$mencoder_threads"
653       video_encoder_opts[2]="chroma_opt"
654       video_encoder_opts[3]="vhq=2"
655       video_encoder_opts[4]="bvhq=1"
656       video_encoder_opts[5]="quant_type=mpeg"
657       video_encoder_opts[6]="autoaspect"
658     fi
659     # Fast (28fps)
660     if [ "$profile" == "xvid" ]; then
661       video_encoder_opts[0]="bitrate=$target_bitrate"
662       video_encoder_opts[1]="threads=$mencoder_threads"
663       video_encoder_opts[2]="vhq=0"
664       video_encoder_opts[3]="turbo"
665       video_encoder_opts[4]="autoaspect"
666     fi
667
668     for OPTS in "${video_encoder_opts[@]}"; do 
669       mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
670     done
671
672     if [ $audio_2ch -eq 0 ]; then
673       # These options produce good 6 channel audio for linux and windows
674       mencoder_audio_opts="-oac copy"
675       # There are 3 different ways to specify 6 channel encoding. We'll try the other ones in order if one of them fails.
676       mencoder_audioch_opts[0]="-channels 6 -af channels=6"
677       mencoder_audioch_opts[1]="-af channels=6"
678       mencoder_audioch_opts[2]=""
679     else
680       # These options produce good 2 channel audio for linux and windows (including the internal mythvideo player)
681       mencoder_audio_opts="-oac mp3lame -lameopts cbr:br=$audio_bitrate"
682       mencoder_audioch_opts[0]=""
683     fi
684  
685   fi
686
687   # iphone and ipod MP4 profiles
688   if [ "$profile" == "iphone" ] || [ "$profile" == "ipod" ]; then
689     found_profile=1
690     if [ "$profile" == "iphone" ]; then
691       # SCALE: 480x320
692       # scale width to 480, set height appropriately, but keep a multiple of 16
693       #SCALE=",scale=480:-10"
694       # scale the video down however far is necessary to fit in 480x320
695       SCALE=",dsize=480:320:0,scale=-8:-8"
696     else
697       # SCALE: 320x240
698       # scale width to 320, set height appropriately, but keep a multiple of 16
699       #SCALE=",scale=320:-10"
700       # scale the video down however far is necessary to fit in 320x240
701       SCALE=",dsize=320:240:0,scale=-8:-8"
702     fi
703     final_output_file="$dest/$dvdname.mp4"
704     mencoder_general_opts="$lang_opts $passlogfile_opt"
705     mencoder_output_opts="-ofps 30000/1001 -sws 9 -of lavf -lavfopts format=mp4"
706     mencoder_video_filter_opts="-vf harddup$CROP$SCALE";
707     mencoder_video_encoder_opts="-ovc x264 -x264encopts $pass_opt"
708     video_encoder_opts[0]="bitrate=$target_bitrate"
709     video_encoder_opts[1]="threads=$mencoder_threads"
710     video_encoder_opts[2]="vbv_maxrate=1500"
711     video_encoder_opts[3]="vbv_bufsize=2000"
712     video_encoder_opts[4]="nocabac"
713     video_encoder_opts[5]="me=umh"
714     video_encoder_opts[6]="subq=6"
715     video_encoder_opts[7]="frameref=6"
716     video_encoder_opts[8]="trellis=1"
717     video_encoder_opts[9]="level_idc=30"
718     video_encoder_opts[10]="global_header"
719     video_encoder_opts[11]="bframes=0"
720     video_encoder_opts[12]="partitions=all"
721     for OPTS in "${video_encoder_opts[@]}"; do 
722       mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
723     done
724
725     mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
726     mencoder_audioch_opts[0]="-channels 2 -srate 48000"
727   fi
728
729   if [ $found_profile -eq 0 ]; then
730     fatal_and_exit "-E- Unable to find a profile handler for profile: $profile"
731   fi
732
733   # Do not edit this line. $mencoder_video_encoder_opts must be last
734   mencoder_opts="$mencoder_general_opts $mencoder_output_opts $mencoder_audio_opts $mencoder_video_filter_opts $mencoder_video_encoder_opts"
735   mencoder_retval=0
736
737   for PASS in $PASSES
738   do 
739     # Set some options based on which pass we are in
740     mencoder_opts_for_pass=$(echo "$mencoder_opts" | sed "s,%PASS,$PASS,g")
741     [ $PASS -eq 1 ] && mencoder_opts_for_pass="$mencoder_opts_for_pass:turbo"
742     [ $PASS -eq 1 ] && output_file="/dev/null"
743     [ $PASS -eq 2 ] && output_file="$final_output_file"
744   
745     # It's possible that the audio channel encoding may not work. Cycle through all our different audioch_opts until we find one that works.
746     for CH_OPTS in "${mencoder_audioch_opts[@]}"; 
747     do
748       echo -e "   Encoding pass $PASS"
749       echo -e "\n   Encoding pass $PASS: mencoder $CH_OPTS $mencoder_opts_for_pass \"$vobfile\" -o \"$output_file\" >> $encodelog 2>&1" >> "$logfile"
750       mencoder $CH_OPTS $mencoder_opts_for_pass "$vobfile" -o "$output_file" > $encodelog 2>&1
751       mencoder_retval=$? 
752       grep -q "\[channels\] Invalid" $encodelog
753       if [ $? != 0 ]; then          
754         break;
755       else
756         echo -e "\n-W- Audio channel encoding error. Falling back to next audio channel encoding scheme." >> "$logfile"
757       fi
758     done
759       
760     if [ $mencoder_retval != 0 ]; then
761       fatal_and_exit "-E- Unhandled mencoder error"
762     fi
763
764     # Concatenate the encode log to our main log file, greping out unwanted lines
765     cat $encodelog | grep -v "^Pos:" | grep -v "duplicate" >> "$logfile"
766
767   done
768 }
769
770 function make_dvd_iso_image {
771
772   isofile="$1"
773
774   # check to see if we have a dvdpath to rip from instead of $dev
775   if [ -z "$dvdpath" ]; then
776     # load the CSS codes in the DVD drive 
777     lsdvd $dev >> "$logfile"
778     if [ $? != 0 ]; then
779       fatal_and_exit "-E- lsdvd $dev failed" 
780     fi
781
782     # read the DVD, ignoring/skipping CRC errors
783     ddrescue -n -b 2048 $dev "$isofile" "$ddrescuelog"
784     if [ $? != 0 ]; then
785       fatal_and_exit "-E- ddrescue -n -b 2048 $dev \"$isofile\" failed"
786     fi
787     cat "$ddrescuelog" >> "$logfile"
788   else
789     # rip from a path instead
790     make_dvd_iso_image_from_folder "$dvdpath" "$isofile" 1
791   fi
792 }
793
794 function make_dvd_iso_image_from_folder {
795   
796   src="$1"
797   dst="$2"
798   handle_error=$3
799   
800   echo "-> Creating ISO image of DVD video: $src -> $dst" | tee -a "$logfile"
801
802   # make an iso image out of our directory
803   echo "   mkisofs -dvd-video \"$src\" 2>> \"$dumplog\" | dd of=\"$dst\" obs=32k seek=0 > /dev/null 2>> $dumplog" >> "$logfile"
804   mkisofs -dvd-video "$src" 2>> "$dumplog" | dd of="$dst" obs=32k seek=0 > /dev/null 2>> "$dumplog"
805
806   # set the audio languages from the iso if it exists and is non-zero in size
807   if [ -s "$dst" ]; then
808     get_feature_title "$dst"
809     get_audio_id_from_iso "$dst"
810   fi
811
812   # make sure we were able to create the iso image from the folder given to us
813   if [ ! -s "$dst" ] && [ $handle_error -eq 1 ]; then
814     echo "-> Unable to make an iso image from the DVD folder: $dvdpath"
815     echo "   Falling back to mplayer to create a main feature VOB from the folder instead: $dvdpath"
816     # remove the bad iso file
817     [[ -e "$dst" ]] && rm -f "$dst"
818     # get the feature title from the DVD folder
819     get_feature_title "$dvdpath"
820     # create our main VOB file from the ISO
821     create_main_vob_with_mplayer "$dvdpath" 
822     # get our audio id from the VOB file
823     get_audio_id_from_vob "$vobfile"
824   fi
825 }
826
827 function make_dvdbackup_folder_image {
828   # extract the feature title from the DVD image
829   echo "-> Extracting feature title using dvdbackup" | tee -a "$logfile"
830   [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
831   dvdbackup -F -i "$isofile" -o "$tmpdir" >> "$logfile"
832   if [ $? != 0 ]; then
833     fatal_and_exit '-E- dvdbackup -F -i "$isofile" -o "$tmpdir" failed'
834   fi
835 }
836
837 function make_dvdauthor_folder_image {
838   # create a new DVD video of the feature title
839   echo "-> Creating DVD video $dest/$dvdname" | tee -a "$logfile"
840   [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
841   dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
842   cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
843
844   # There is a chance that dvdauthor won't like some of the VOBs.
845   # We can't tell ahead of time which ones it will choke on. 
846   # So, we need to run it over and over again until it can process
847   # all the VOBs. If it can't handle one of them, run it through
848   # mencoder to fix it and try again. These errors are typically
849   # present due to the copy protection that ddrescue removed.
850   grep -q "SCR moves" $dvdauthorlog
851   while [ $? == 0 ]; do
852     # fix bad vobs that get the "SCR moves backwards" error:
853     #  STAT: Processing VTS_01_0.VOB...
854     #  ERR:  SCR moves backwards, remultiplex input.
855     badvob=`grep -v "^WARN:" $dvdauthorlog | grep -B 1 "SCR moves" | grep "Processing" | awk '{ print $3 }' | sed -e 's/\.\.\.//'`
856     if [[ ! -f "$badvob" ]]; then
857       fatal_and_exit "-E- Found a bad VOB, but could not extract it's name properly: $badvob"
858     fi
859     echo "-> Fixing SCR errors in DVD video file $badvob" | tee -a "$logfile"
860     cat $badvob | mencoder $lang_opts -quiet -of mpeg -mpegopts format=dvd -oac copy -ovc copy - -o $badvob.fixed >> "$logfile" 2>&1
861     mv -f $badvob.fixed $badvob
862     echo "-> Creating DVD video $dest/$dvdname"
863     dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
864     cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
865     grep -q "SCR moves" $dvdauthorlog
866   done
867 }
868
869 function get_feature_title {
870   source="$1"
871   # if a feature title was given on the command line, use it
872   if [ $feature_title_override -ne 0 ]; then
873     feature_title=$feature_title_override
874     return 0
875   fi
876   # otherwise, use lsdvd to figure it out
877   if [ $ripdvd -eq 1 ]; then
878     feature_title=`lsdvd $dev | awk '/Longest/ { print $NF }'`
879   else 
880     feature_title=`lsdvd "$source" 2>/dev/null | awk '/Longest/ { print $NF }'`
881   fi
882 }
883
884 function create_main_vob_with_cat {
885   # cd to the feature title DVD folder
886   pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
887   if [ $? != 0 ]; then
888     fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
889   fi
890
891   # concatenate all the VOBs together into 1 giant VOB
892   vobs=`/bin/ls -1 VTS*.VOB | grep -v "0.VOB" | tr '\n' ' '`
893   cat $vobs > "$tmpdir/$dvdname.VOB"
894
895   # cd back to the dir we started from
896   popd > /dev/null 2>&1
897 }
898
899 function create_main_vob_with_mplayer {
900
901   # argument processing  
902   source="$1"
903   remove_dumplog=$2
904
905   # make sure we have a valid feature title
906   if [ $invalid_feature_title -eq 1 ] && [ $feature_title_override -eq 0 ]; then
907     fatal_and_exit "-E- You must have a valid feature title to get the VOB via mplayer dumpstream. We can't determine the feature title for this DVD."
908   fi
909
910   # check to make sure we didn't detect an mplayer dumpstream incompatibility earlier
911   if [ $mplayer_dumpstream_incompatibility -eq 1 ]; then
912     msg="-E- We detected an mplayer dumpstream incompatibility earlier."
913     msg="$msg We also detected another condition that requires us to use dumpstream. "
914     msg="$msg\n    Unable to rip this DVD in the mode you requested."
915     fatal_and_exit "$msg"
916   fi
917
918   # use mplayer to create the main VOB file
919   echo "-> Using mplayer to dump the DVD feature title $feature_title to a VOB file directly: $vobfile" | tee -a "$logfile"
920   echo "   mplayer $lang_opts -dumpstream -dumpfile \"$vobfile\" -dvd-device \"$source\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
921   mplayer $lang_opts -dumpstream -dumpfile "$vobfile" -dvd-device "$source" dvd://$feature_title > $dumplog 2>&1
922   if [ $? != 0 ]; then
923     cat $dumplog | grep -v "^A:" >> "$logfile"
924     fatal_and_exit "-E- Mplayer Failed"
925   fi
926   cat $dumplog | grep -v "^A:" >> "$logfile"
927   [[ -e "$dumplog" ]] && [[ $remove_dumplog -eq 1 ]] && rm -f $dumplog
928 }
929
930 function get_audio_id_from_iso {
931   # Adjust our audio ID to find the english audio stream
932   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
933   iso="$1"
934   aidcheck=`tempfile`
935   aid=$default_aid
936   alang=$default_alang
937   if [ $aid_override -lt 0 ]; then 
938     mplayer -v -endpos 0 -dvd-device "$iso" dvd://$feature_title > $aidcheck 2>&1
939     grep -q "aid: $aid" $aidcheck
940     while [ $? == 1 ] && [ $aid -lt 159 ]; do
941       (( aid = aid + 1 ))
942       grep -q "aid: $aid" $aidcheck
943     done
944     [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
945   else
946     aid=$aid_override
947   fi
948   echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
949   # mencoder default DVD audio track language selection (english)
950   lang_opts="-aid $aid -alang $alang"
951 }
952
953 function get_crop_from_iso { 
954   FRAMES=10000
955   echo "-> Detecting black frame border crop value from ISO file"
956   echo "   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device \"$isofile\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
957   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device "$isofile" dvd://$feature_title > $dumplog 2>&1
958   [[ -e "md5sums" ]] && rm -f "md5sums"
959   CROP=`cat $dumplog | grep CROP | tail -1`
960   echo "   Found crop value of $CROP" >> "$logfile"
961   CROP=${CROP#* crop=}
962   CROP=${CROP%%\).*}
963   typeset -i CROPCHECK
964   CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
965   echo "   Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
966   if [ -z "$CROP" ]; then
967     echo "-W- Unable to extract CROP value from iso: $isofile" | tee -a "$logfile"
968     return
969   fi
970   if [ $CROPCHECK -lt 0 ]; then 
971     CROP=""
972   else 
973     CROP=",crop=$CROP"
974   fi
975   echo "   Setting mencoder crop filter to: $CROP"
976 }
977
978 function get_crop_from_vob { 
979   FRAMES=10000
980   echo "-> Detecting black frame border crop value from VOB file"
981   echo "   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark \"$vobfile\" > $dumplog 2>&1" >> "$logfile"
982   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark "$vobfile" > $dumplog 2>&1
983   [[ -e "md5sums" ]] && rm -f "md5sums"
984   CROP=`cat $dumplog | grep CROP | tail -1`
985   echo "   Found crop value of $CROP" >> "$logfile"
986   CROP=${CROP#* crop=}
987   CROP=${CROP%%\).*}
988   typeset -i CROPCHECK
989   CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
990   echo "   Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
991   if [ -z "$CROP" ]; then
992     echo "-W- Unable to extract CROP value from iso: $isofile" | tee -a "$logfile"
993     return
994   fi
995   if [ $CROPCHECK -lt 0 ]; then 
996     CROP=""
997   else 
998     CROP=",crop=$CROP"
999   fi
1000   echo "   Setting mencoder crop filter to: $CROP"
1001 }
1002
1003 function get_audio_track_from_vob {
1004   # Adjust our audio ID to find the english audio stream
1005   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
1006   vob="$1"
1007   aidcheck=`tempfile`
1008   aid=$default_aid
1009   alang=$default_alang
1010   if [ $aid_override -lt 0 ]; then 
1011     mplayer -v -endpos 0 "$vob" > $aidcheck 2>&1
1012     grep -q "Found audio stream: $aid" $aidcheck
1013     while [ $? == 1 ] && [ $aid -lt 159 ]; do
1014       (( aid = aid + 1 ))
1015       grep -q "Found audio stream: $aid" $aidcheck
1016     done
1017     [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
1018   else 
1019     aid=$aid_override
1020   fi
1021   # Now that we've found the right audio id, find the corresponding audio track in HandBrake
1022
1023   # convert the aid we found into hex
1024   aid_hex=`echo "obase=16; $aid" | bc`
1025   
1026   # extract the audio streams in the vob
1027   ffmpeg -i "$vob" > $aidcheck 2>&1
1028   
1029   # find the stream that matches our aid
1030   stream=`grep "Stream.*\[0x$aid_hex\]" $aidcheck`
1031  
1032   # extract the track number that handbrake uses
1033   track=`expr match "$stream" '.*#[0-9]\.\([0-9]*\)'`
1034
1035   if [ -n "$track" ]; then   
1036     echo "-> Setting the audio ID to $aid. Setting the audio track to $track." | tee -a "$logfile"
1037   fi
1038 }
1039
1040 function get_audio_id_from_vob {
1041   # Adjust our audio ID to find the english audio stream
1042   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
1043   vob="$1"
1044   aidcheck=`tempfile`
1045   aid=$default_aid
1046   alang=$default_alang
1047   if [ $aid_override -lt 0 ]; then 
1048     mplayer -v -endpos 0 "$vob" > $aidcheck 2>&1
1049     grep -q "Found audio stream: $aid" $aidcheck
1050     while [ $? == 1 ] && [ $aid -lt 159 ]; do
1051       (( aid = aid + 1 ))
1052       grep -q "Found audio stream: $aid" $aidcheck
1053     done
1054     [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
1055   else 
1056     aid=$aid_override
1057   fi
1058   echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
1059   # mencoder default DVD audio track language selection (english)
1060   lang_opts="-aid $aid -alang $alang"
1061 }
1062
1063 function check_vob_for_corrupted_start {
1064   # check to see if the beginning of the DVD has a form of copy protection
1065   # where they have deliberately broken the first X number of frames of the DVD.
1066   # If we don't skip these, our resulting VOB file will not play.
1067   badvobcheck=`tempfile`
1068   endpos=360
1069   skip=0
1070   mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
1071   if [ $? != 0 ]; then
1072     fatal_and_exit "-E- Mencoder Failed"
1073   fi
1074   grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
1075   while [ $? == 0 ] && [ $skip -lt $endpos ]; do
1076     (( skip = skip + 5 ))
1077     echo "-> Bad VOB copy protection detected. Trying new skip value of $skip" | tee -a "$logfile"
1078     mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
1079     if [ $? != 0 ]; then
1080       fatal_and_exit "-E- Mencoder Failed"
1081     fi
1082     grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
1083   done
1084   [[ -e "$badvobcheck" ]] && rm -f "$badvobcheck";
1085
1086   # cat the giant VOB into mencoder to create a playable VOB file
1087   cat "$tmpdir/$dvdname.VOB" | mencoder -ss $skip -quiet $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy - -o "$vobfile" >> "$logfile" 2>&1
1088   if [ $? != 0 ]; then
1089     fatal_and_exit "-E- Mencoder Failed"
1090   fi
1091 }
1092
1093 function check_vob_for_completeness {
1094   # check to make sure we got out a complete VOB.
1095   # there is another kind of copy protection where the VOB's may
1096   # have "MPG EOF" frames in the middle of the stream. 
1097   # this causes mencoder to not process the entire VOB, and exit without any errors.
1098   # detect this by seeing how much smaller the dst vob is from the src vob.
1099   MAX_FILESIZE_DELTA_PERCENT=70
1100   SRC_VOB_FILESIZE=$(stat -c%s "$tmpdir/$dvdname.VOB")
1101   DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
1102   FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
1103   if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
1104     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
1105     echo "-> Detected bad VOB size copy protection after processing concatenated VOB file." | tee -a "$logfile"
1106     create_main_vob_with_mplayer "$isofile"
1107     [[ -e "$dumplog" ]] && rm -f $dumplog
1108     DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
1109     FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
1110     if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
1111       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n    I recommend using another ripping mode like '-m' or '-i'"
1112     fi
1113   fi
1114 }
1115
1116 function check_vob_for_too_many_video_packets {
1117   # If our earlier algorithm to work around this failed, throw an error.
1118   # check to see if this DVD has a protection scheme we don't know how to work around
1119   # when I tried to burn the CARS DVD for example, you can't play the resulting VOB file.
1120   # for some reason, the video is black, while the audio rolls, then the video finally comes
1121   # in, but it is WAY off the audio. This appears to be due to some bad frames at the beginning of 
1122   # the 1st VOB. Until I figure out how to work around this, detect it, and error out.
1123   # instead of pulling the image from the disk again, you can pull it directly from the iso: -dvd-device $iso_path
1124   grep -q "Too many video packets in the buffer:" "$logfile"
1125   if [ $? == 0 ]; then
1126     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
1127     echo "-> Detected corrupt audio stream copy protection after processing concatenated VOB file." | tee -a "$logfile"
1128     create_main_vob_with_mplayer "$isofile"
1129     grep -q "Too many video packets in the buffer:" $dumplog
1130     if [ $? == 0 ]; then
1131       [[ -e "$dumplog" ]] && rm -f $dumplog
1132       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n   I recommend using another ripping mode like '-m' or '-i'"
1133     fi
1134     [[ -e "$dumplog" ]] && rm -f $dumplog
1135   fi
1136 }
1137
1138 function check_vob_for_a52_crc_errors {
1139   # Let's see if we can playback our newly created VOB file without any errors.
1140   # if there are issues, let's detect them now, and try to recreate the VOB
1141   # there are some forms of copy protection that have missed above, that evidence
1142   # themselves when we try to playback the VOB file. This was added to deal with
1143   # the "a52: CRC check failed" copy protection scheme.
1144   MAX_ERRORS=10
1145   ENDPOS=120
1146   echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
1147   mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
1148   cat $dumplog | grep -v "^A:" >> "$logfile"
1149   errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
1150   if [ $errors -gt $MAX_ERRORS ]; then
1151     echo "-> Detected a52 audio stream CRC errors copy protection after processing concatenated VOB file." | tee -a "$logfile"
1152     create_main_vob_with_mplayer "$isofile"
1153     echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
1154     mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
1155     if [ $? != 0 ]; then
1156       cat $dumplog | grep -v "^A:" >> "$logfile"
1157       fatal_and_exit "-E- Mplayer Failed"
1158     fi
1159     cat $dumplog | grep -v "^A:" >> "$logfile"
1160     errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
1161     if [ $errors -gt $MAX_ERRORS ]; then
1162       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n   I recommend using another ripping mode like '-m' or '-i'"
1163     fi
1164   fi
1165   [[ -e "$dumplog" ]] && rm -f $dumplog
1166 }
1167
1168 function calculate_bitrate_from_target_size {
1169   # determine what our bitrate needs to be if a target size was specified instead
1170   if [ $target_size -ne 0 ]; then
1171     vob_length=`mplayer -identify -v "$vobfile" -endpos 0 2>&1 | grep ID_LENGTH | awk -F '=' '{ print $2 }' | awk -F '.' '{ print $1 }'`
1172     ((target_bitrate = (target_size * 1024 * 8) / vob_length ))
1173     echo "   With a given target size of $target_size MB, the estimated bit rate will need to be $target_bitrate kbits/sec"
1174   fi
1175 }
1176
1177 function create_dvdauthor_dvd_xml_file {
1178   # make a dvdauthor xml menu file to create a valid DVD video from 
1179   # this script does a good job, but we'll still need to clean it up a bit after it runs
1180   echo "-> Creating dvdauthor XML menu file" | tee -a "$logfile"
1181   makexml -overwrite -dvd *.VOB -out dvd >> "$logfile" 2>&1
1182   if [ $? != 0 ]; then
1183     fatal_and_exit '-E- makexml -dvd *.VOB -out dvd failed'
1184   fi
1185
1186   # replace the first line of the xml file to remove the bad dest path
1187   awk -v line=1 -v new_content="<dvdauthor>" '{
1188     if (NR == line) {
1189       print new_content;
1190     } else {
1191       print $0;
1192     }
1193   }' dvd.xml > dvd.xml.new
1194   mv -f dvd.xml.new dvd.xml
1195   if [ $? != 0 ]; then
1196     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1197   fi
1198
1199   # remove the "<video " property line from the xml file
1200   cat dvd.xml | grep -v "<video" > dvd.xml.new
1201   mv -f dvd.xml.new dvd.xml
1202   if [ $? != 0 ]; then
1203     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1204   fi
1205   
1206   # remove the extra <pgc>..</pgc> pairs
1207   cat dvd.xml | awk 'BEGIN {x=1}
1208   {
1209     if ($0~"</pgc>") {x=0}
1210     if (x==1) {print $0}
1211     if ($0~"<pgc>") {x=1}
1212   }' > dvd.xml.new
1213   echo -e "</pgc>\n</titles>\n</titleset>\n</dvdauthor>" >> dvd.xml.new
1214   mv -f dvd.xml.new dvd.xml
1215   if [ $? != 0 ]; then
1216     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1217   fi
1218
1219   # remove the VTS_*_0.VOB file as this is just the main menu video clip
1220   cat dvd.xml | grep -v "VTS_.*_0.VOB" > dvd.xml.new
1221   mv -f dvd.xml.new dvd.xml
1222   if [ $? != 0 ]; then
1223     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1224   fi
1225 }
1226
1227 function check_for_mplayer_dumpstream_incompatibility {
1228
1229   echo "-> Checking for mplayer dumpstream incompatibilities" | tee -a "$logfile"
1230
1231   if [ ! -e "$vobfile" ]; then
1232     # mplayer dumpstream does not work on DVDs that obscure the feature title.
1233     # A DVD that has 99 titles, where the longest title isn't the main feature
1234     # breaks mplayer dumpstream. We have to fallback to using dvdbackup to figure
1235     # out what the feature title is. This script will run through that flow if we
1236     # set use_mplayer_dumpstream to 0. Check for this here.
1237     if [ $ripdvd -eq 1 ]; then
1238       lsdvd $dev | grep -q "Title: 99"
1239     else
1240       lsdvd "$isofile" | grep -q "Title: 99"
1241     fi
1242     # If we have 99 titles and a feature title wasn't given on the command line, switch modes.
1243     if [ $? == 0 ] && [ $feature_title_override -eq 0 ]; then
1244       if [ $trust_feature_title_autodetect_when_uncertain -eq 0 ]; then
1245         echo "-E- Unable to determine the feature title due to the 99 title copy protection scheme" | tee -a "$logfile"
1246         echo "    You will need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
1247         echo "    You can google this DVD to find out what it's feature title is, or you can play it in a conventional DVD player to find it." | tee -a "$logfile"
1248         invalid_feature_title=1
1249       else 
1250         echo "    Falling back to non mplayer dumpstream methods to copy the DVD" | tee -a "$logfile"
1251         echo "-W- We still may not be able to autodetect the right feature title" | tee -a "$logfile"
1252         echo "    You may need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
1253         use_mplayer_dumpstream=0
1254         invalid_feature_title=1
1255       fi
1256       return
1257     fi
1258   fi
1259
1260   # There is another form of protection that causes the mplayer dumpstream to fail. 
1261   # This can be detected by telling mplayer to parse the VOB file by copying its audio
1262   # video streams to a dummy output file (/dev/null). Do that here to check for that 
1263   # problem before continuing.
1264   if [ -e "$vobfile" ]; then
1265     mplayer_opts="-quiet -ofps 30000/1001 -ffourcc DIVX -oac copy -ovc copy"
1266     mencoder $mplayer_opts "$vobfile" -o "/dev/null" > $dumplog 2>&1
1267     grep -q "Too many audio packets in the buffer" $dumplog
1268     if [ $? == 0 ]; then
1269       echo "-> The VOB dumped by mplayer is invalid. Falling back to non mplayer dumpstream to copy the DVD" | tee -a "$logfile"
1270       use_mplayer_dumpstream=0
1271       mplayer_dumpstream_incompatibility=1
1272     fi
1273     [[ -e "$dumplog" ]] && rm -f $dumplog
1274   fi
1275 }
1276
1277 function fill_mythvideo_metadata {
1278
1279   # This function must be passed the filename as an argument
1280   # The filename must be a full path to the file
1281   filename="$1"
1282
1283   # Make sure the fill mythvideo metadata option has been set to 1
1284   if [ $fill_mythvideo_metadata -eq 0 ]; then
1285     echo "-> fill_mythvideo_metadata=0 therefore not updating mythvideo metadata for this rip" | tee -a "$logfile"
1286     return 0
1287   fi
1288
1289   # If the fill mythvideo metadata script is present, run it
1290   # fill_mythvideo_metadata.plThis will download the metadata for the DVD we ripped.
1291   if [[ -x `which fill_mythvideo_metadata.pl` ]]; then
1292     echo "-> Running fill_mythvideo_metadata.pl to lookup/add/update the metadata for this DVD: $filename" | tee -a "$logfile"
1293     fill_mythvideo_metadata.pl -N 0 -F "$filename" >> "$logfile" 2>&1
1294   else
1295     echo "-W- Unable to find the fill_mythvideo_metadata.pl script in your PATH. Unable to autofill the mythvideo DB for this rip." | tee -a "$logfile"
1296     echo "    Set the fill_mythvideo_metadata variable to 0 in the script to avoid running this step." | tee -a "$logfile"
1297   fi
1298 }
1299
1300 # remove the intermediate VOB file
1301 function remove_intermediate_vob_file {
1302   if [ $keep_intermediate_files -eq 0 ]; then
1303     [[ -e "$tmpdir/$dvdname.VOB" ]] && rm -f "$tmpdir/$dvdname.VOB"
1304   else
1305     echo "-> Keeping intermediate concatenated VOB file: $tmpdir/$dvdname.VOB" | tee -a "$logfile"
1306   fi
1307 }
1308
1309 # remove the original DVD image 
1310 function remove_intermediate_iso_file {
1311   [[ $keep_isofile -eq 1 ]] && return 1
1312   if [ $keep_intermediate_files -eq 0 ]; then
1313     [[ -e "$isofile" ]] && rm "$isofile"
1314   else
1315     echo "-> Keeping ddrescue intermediate iso file: $isofile" | tee -a "$logfile"
1316   fi
1317 }
1318
1319 # remove the intermediate dvdbackup folder
1320 function remove_intermediate_dvdbackup_folder {
1321   if [ $keep_intermediate_files -eq 0 ]; then
1322     [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
1323   else
1324     echo "-> Keeping intermediate dvdbackup folder: $tmpdir/$dvdname" | tee -a "$logfile"
1325   fi
1326 }
1327
1328 ##############################################################################################
1329 # MAIN
1330 ##############################################################################################
1331
1332 # Make a note of when this DVD rip started
1333 date=`date`
1334 echo -e "\n$date DVD rip started" >> "$logfile"
1335 echo "$cmd" >> "$logfile"
1336
1337 # Rip the DVD - Mirror Mode
1338 if [ $mirror_mode -eq 1 ]; then
1339   echo "-> Ripping DVD $dvdname to $dest"
1340
1341   # use ddrescue to make an ISO image of the disk
1342   make_dvd_iso_image "$dest/$dvdname.iso"
1343
1344   # add this video data to the mythtv DB
1345   fill_mythvideo_metadata "$dest/$dvdname.iso" 
1346
1347   # eject the disk upon completion
1348   if [ $eject_disk -ne 0 ]; then
1349     eject -T $dev
1350   fi
1351
1352   date=`date`
1353   echo "$date DVD rip completed" | tee -a "$logfile"
1354
1355   if [[ -n "$mailto" ]]; then
1356     cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
1357   fi
1358
1359 fi
1360
1361 # Rip the DVD - Main Title Feature Only
1362 if [ $mirror_mode -eq 0 ]; then
1363
1364   # Rip image from DVD
1365   if [ $ripdvd -eq 1 ]; then
1366     echo "-> Ripping DVD $dvdname to $dest" | tee -a "$logfile"
1367     # use ddrescue to make an ISO image of the disk
1368     make_dvd_iso_image "$tmpdir/$dvdname.iso"
1369   fi
1370
1371   # Rip image from DVD path
1372   if [ -n "$dvdpath" ]; then
1373     echo "-> Ripping DVD $dvdpath to $dest" | tee -a "$logfile"
1374     make_dvd_iso_image_from_folder "$dvdpath" "$tmpdir/$dvdname.iso" 1
1375   fi
1376
1377   # make sure our isofile value is set
1378   if [ -z "$isofile" ]; then
1379     isofile="$tmpdir/$dvdname.iso"
1380   fi
1381      
1382   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_comp -eq 1 ]; then
1383
1384     if [ ! -e "$vobfile" ]; then
1385       echo "-> Creating DVD video $vobfile" | tee -a "$logfile"
1386       
1387       # get the feature title from the ISO
1388       get_feature_title "$isofile"
1389  
1390       # get the crop value from the ISO
1391       get_crop_from_iso
1392
1393       # check for mplayer dumpstream incompatibilities
1394       # if they exist, this method will set this mode to 0.
1395       check_for_mplayer_dumpstream_incompatibility
1396
1397       if [ $use_mplayer_dumpstream -eq 1 ]; then 
1398
1399         # get our audio id from the ISO file
1400         get_audio_id_from_iso "$isofile"
1401
1402         # create our main VOB file from the ISO
1403         create_main_vob_with_mplayer "$isofile"
1404      
1405         # remove the intermediate VOB file
1406         remove_intermediate_vob_file
1407
1408         # it's possible that our VOB is still corrupted in some manner
1409         # check to make sure it is still a good VOB before continuing.
1410         check_for_mplayer_dumpstream_incompatibility
1411
1412       fi
1413  
1414       if [ $use_mplayer_dumpstream -eq 0 ]; then 
1415
1416         # use dvdbackup to make a DVD folder of the feature title
1417         make_dvdbackup_folder_image
1418   
1419         # create our main VOB file
1420         create_main_vob_with_cat
1421
1422         # get our audio id from the VOB file
1423         get_audio_id_from_vob "$tmpdir/$dvdname.VOB"
1424   
1425         # check for corrupted VOB start
1426         check_vob_for_corrupted_start
1427  
1428         # check to make sure our VOB is complete
1429         check_vob_for_completeness
1430
1431         # check to make sure our VOB doesn't have too many video packets
1432         check_vob_for_too_many_video_packets
1433
1434         # check to make sure our VOB doesn't have a52 crc errors
1435         check_vob_for_a52_crc_errors
1436
1437         # remove the intermediate VOB file
1438         remove_intermediate_vob_file
1439
1440       fi
1441
1442       # remove the intermediate ISO file
1443       remove_intermediate_iso_file
1444
1445     else
1446       if [ "$encoder" != "handbrake" ]; then 
1447         echo "-> Skipping VOB creation. VOB DVD video already exists: $vobfile" | tee -a "$logfile"
1448         # get our audio id from the VOB file
1449         get_audio_id_from_vob "$vobfile"
1450         # get the crop value from the VOB
1451         get_crop_from_vob
1452       fi
1453     fi
1454
1455     # eject the DVD disk since we are finished with it
1456     [ $eject_disk -eq 2 ] && eject -T $dev
1457
1458     # encode the VOB file to a compressed file format
1459     if [ $make_final_dest_comp -eq 1 ]; then
1460       echo "-> Encoding the DVD video to a compressed file using $encoder" | tee -a "$logfile"
1461
1462       # determine what our bitrate needs to be if a target size was specified instead
1463       calculate_bitrate_from_target_size        
1464      
1465       # encode the vob file into a compressed file format
1466       if [[ "$encoder" == "mencoder" ]]; then 
1467         encode_vob_file_mencoder
1468       fi
1469       if [[ "$encoder" == "handbrake" ]]; then
1470         encode_vob_file_handbrake
1471       fi
1472
1473       if [ $keep_intermediate_files -eq 0 ] && [ $make_final_dest_vob -eq 0 ]; then
1474         [[ -e "$vobfile" ]] && [[ $keep_vobfile -eq 0 ]] && rm -f "$vobfile";
1475         [[ -e "$passlogfile" ]] && rm -f "$passlogfile";
1476       else
1477         echo "-> Keeping VOB file: $vobfile" | tee -a "$logfile"
1478         echo "-> Keeping mencoder 2pass logfile: $passlogfile"
1479       fi
1480     fi
1481
1482   # add this video data to the mythtv DB
1483   [ $make_final_dest_comp -eq 1 ] && fill_mythvideo_metadata "$final_output_file" 
1484   [ $make_final_dest_vob -eq 1 ] && fill_mythvideo_metadata "$vobfile" 
1485     
1486   else
1487
1488   # use dvdbackup to make a DVD folder of the feature title
1489   make_dvdbackup_folder_image
1490
1491   # cd to the feature title DVD folder
1492   pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
1493   if [ $? != 0 ]; then
1494     fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
1495   fi
1496   
1497   # create the dvd.xml file for dvdauthor
1498   create_dvdauthor_dvd_xml_file  
1499
1500   # make the final DVD folder image
1501   make_dvdauthor_folder_image
1502
1503   # add this video data to the mythtv DB
1504   fill_mythvideo_metadata "$dest/$dvdname/VIDEO_TS" 
1505  
1506   # cd back to the dir we started from
1507   popd > /dev/null 2>&1
1508
1509   if [ $make_final_dest_iso -eq 1 ]; then
1510
1511     # make an iso image out of our directory
1512     make_dvd_iso_image_from_folder "$dest/$dvdname" "$dest/$dvdname.iso" 0
1513    
1514     # If the mkisofs was unable to make a .iso file for us, don't remove the DVD directory 
1515     if [ -s "$dest/$dvdname.iso" ]; then
1516       if [ $make_final_dest_folder -eq 0 ]; then
1517         echo "-> Removing DVD folder since ISO was created: $dest/$dvdname" | tee -a "$logfile"
1518         # remove the folder of the DVD image now that we have a .iso version of it
1519         [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
1520       fi
1521     else
1522       # we created an empty iso file, remove it
1523       echo "-> Removing empty ISO image: $dest/$dvdname.iso" | tee -a "$logfile"
1524       echo "-> Keeping the DVD folder since the ISO image couldn't be created properly: $dest/$dvdname"
1525       [[ -e "$dest/$dvdname.iso" ]] && rm "$dest/$dvdname.iso"
1526     fi
1527  
1528     # add this video data to the mythtv DB
1529     fill_mythvideo_metadata "$dest/$dvdname.iso" 
1530
1531   fi
1532
1533   fi
1534
1535   # remove the ddrescue DVD ISO image
1536   remove_intermediate_iso_file
1537
1538   # remove the tmp dvdbackup folder of the DVD image
1539   remove_intermediate_dvdbackup_folder
1540
1541   # eject the DVD disk upon completion
1542   [ $eject_disk -eq 1 ] && eject -T $dev
1543
1544   date=`date`
1545   echo "$date DVD rip completed" | tee -a "$logfile"
1546
1547   if [[ -n "$mailto" ]]; then
1548     cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
1549   fi
1550
1551 fi
1552
1553 ##############################################################################################